SystemOrganization addCategory: #'Mustache-Core'!
SystemOrganization addCategory: #'Mustache-Test'!

JsonObject subclass: #MustacheTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Core'!

MustacheTemplate class
	instanceVariableNames: 'instance'!

MustacheTemplate class
	instanceVariableNames: 'instance'!

!MustacheTemplate class methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/28/2012 11:52'!
instance
super initialize.
instance:=self new.
self subclasses do:[:aSubClass|
	instance addPartial: aSubClass instance
].
instance initialize.
^instance! !

!MustacheTemplate class methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/21/2012 22:16'!
partials
^ self instance partials! !

!MustacheTemplate methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 20:13'!
addPartial:aMustachePartial

| p |
p:=self at:'partials' ifAbsent:[self at:'partials' put: JsonObject new].
p at:(aMustachePartial class asString) put:(aMustachePartial render)
! !

!MustacheTemplate methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/15/2012 12:32'!
render
	"return an Template within a string"
self subclassResponsibility ! !

MustacheTemplate subclass: #MustacheTest1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Test'!

!MustacheTest1 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:14'!
render
	"return an Template within a string"

^'Simple test

Hello {{name}}
you work as a {{profession}}'! !

MustacheTemplate subclass: #MustacheTest2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Test'!

!MustacheTest2 methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 20:38'!
render
	"return an Template within a string"

^'Function test
Hello {{name}}
you work as a {{profession}}
Your salary is ${{salary}}!!
{{#inCa}}
Ok, in fact it is ${{funcion}} after you pay the taxes.
{{/inCa}}
{{#person}}
Ok, in fact it is ${{funcion}} 
{{/person}}
'! !

MustacheTemplate subclass: #MustacheTest3
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Test'!

!MustacheTest3 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:15'!
render
	"return an Template within a string"

^'Escaped/non escaped test

*{{name}}
*{{profession}}
*{{company}}
*{{{company}}}
'! !

MustacheTemplate subclass: #MustacheTest4
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Test'!

!MustacheTest4 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:15'!
render
	"return an Template within a string"

^'Non Empty List test

{{name}}
{{profession}}
{{company}}
*non escaped company:{{{company}}}
{{#experience}}
--{{job}}
{{/experience}}

'! !

MustacheTemplate subclass: #MustacheTest5
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Test'!

!MustacheTest5 methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/21/2012 22:23'!
render
	"return an Template within a string"

^'Lambdas test

Name:{{name}}, Profession:{{profession}}
Working at:{{company}}
------------------------------------------
Experience
{{#experience}}
{{job}}
{{/experience}}
------------------------------------------
Salary:
{{#wrapped}}
{{salary}}
{{/wrapped}}

'! !

MustacheTemplate subclass: #MustacheTest6
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Test'!

!MustacheTest6 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:16'!
render
	"return an Template within a string"

^'Non False Values Test

Hash:
{
	"person" :{"name": "Jon"}
}

Template:
{{#person}}
Hi {{name}}!!
{{/person}}

'! !

MustacheTemplate subclass: #MustacheTest7
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Test'!

!MustacheTest7 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:17'!
render
	"return an Template within a string"

^'Inverted Section Test

Hash:
{
	"repo":[]
}

{{#repo}}
	<b>{{name}}</b>
{{/repo}}
{{^repo}}
	No repos :(
{{/repo}}
'! !

MustacheTemplate subclass: #MustacheTest8
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Test'!

!MustacheTest8 methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 16:56'!
render
	"return an Template within a string"

^'Comments Test

<h1>Today{{!! a comment 

is an strange world}} is Monday!!</h1>

Lambdas test

Name:{{name}}, Profession:{{profession}}
Working at:{{company}}
------------------------------------------
Experience
{{#experience}}
{{job}}
{{/experience}}
------------------------------------------
Salary:
{{#wrapped}}
{{>Partial1}}
{{/wrapped}}
'! !

MustacheTest8 subclass: #Partial1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Test'!

!Partial1 methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 16:19'!
render
^'{{salary}}'! !

MustacheTest8 subclass: #Partial2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Test'!

MustacheTemplate subclass: #MustacheTest9
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Test'!

!MustacheTest9 methodsFor: 'as yet unclassified' stamp: 'JesusMari 6/18/2012 13:18'!
render
	"return an Template within a string"

^'Set Delimiters Test

* {{default_tags}}
{{=<% %>=}}
* <% erb_style_tags %>
<%={{ }}=%>
*{{default_tags_again}}
'! !

Object subclass: #Mustache
	instanceVariableNames: 'stack partials parser'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Mustache-Core'!

!Mustache class methodsFor: 'accessing' stamp: 'JesusMari 9/22/2012 17:11'!
cacheSize
"Cache size> when the size is grater than xxx deletes a half of the cached templates"
^20! !

!Mustache class methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/22/2012 17:29'!
clearCache
self new clearCache! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 9/22/2012 17:05'!
render:aTemplate view:aView 
^Mustache toHtml:aTemplate view:aView
! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 9/21/2012 22:12'!
render:aTemplate view:aView  partials:aPartialNode
^Mustache toHtml:aTemplate asString view:aView partials:aPartialNode
! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 9/22/2012 00:55'!
toHtml:aTemplate view:aView 
|part|

(aTemplate superclass = MustacheTemplate) 
ifTrue:[
		part:=aTemplate partials.
	].
^Mustache toHtml:aTemplate view:aView partials:part
! !

!Mustache class methodsFor: 'instance creation' stamp: 'JesusMari 9/22/2012 17:25'!
toHtml:aTemplate view:aView partials:partialsNode
| compiler tmp templ|

(aTemplate class superclass = MustacheTemplate class) 
ifTrue:[
		templ:=aTemplate instance render.
	]
ifFalse:[
	templ:=aTemplate asString.
	].
compiler:=self new.
compiler stack: (OrderedCollection with:aView).
compiler partials: partialsNode.
tmp:= compiler render: templ view: aView. 

^tmp! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 8/24/2012 18:25'!
cache
	^ Cache! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 8/24/2012 18:25'!
cache: anObject
	Cache := anObject! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/22/2012 17:50'!
clearCache
self cache removeAll.


! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/12/2012 10:38'!
compile:aTemplate 
"Compiles the given ttemplate into a reusable function using the given options. In addiction to the options accepted by #parse: options: recogniced options include the folllowing:
- cache 	Set 'false' to bypass any pre-compiled version of the given template. Otherwise, a given 'template' string will be cached the first time it is parsed"
	
	^self compile:aTemplate options:JsonObject new! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 16:40'!
compile:aTemplate options:aJsonObjOptions
"Compiles the given ttemplate into a reusable function using the given options. In addiction to the options accepted by #parse: options: recogniced options include the folllowing:
- cache 	Set 'false' to bypass any pre-compiled version of the given template. Otherwise, a given 'template' string will be cached the first time it is parsed"
	
| cblock |
( aJsonObjOptions at:'cache' ifAbsent:[true])
ifTrue:[
	(self cache includesKey:aTemplate) 
	ifFalse:[
			cblock:=self rcompile:aTemplate options:aJsonObjOptions.
			cblock ifNotNil:[self cache at:aTemplate put: cblock].	
		].
	^ self cache at:aTemplate.	
	].
^  self rcompile:aTemplate options:aJsonObjOptions! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 20:19'!
escapeHTML: aString
|result table |


table:=JsonObject fromAssociations: {
	'&'-> '&amp;'.
	'<'->'&lt;'.
	'>'->'&gt;'.
	'"'->'&quot;'.
	''''->'&#39;'.
	}.

result:= aString asString copyWithRegex: '[&<>"'']+' matchesTranslatedUsing: [:ch| table at: ch].

^result! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 20:19'!
escapePlain: aString

^aString asString! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/25/2012 16:47'!
importAllPartialsFrom:aFolderPath 
self importAllPartialsFrom:aFolderPath relPath:''! !

!Mustache methodsFor: 'private' stamp: 'JesusMari 5/25/2012 17:07'!
importAllPartialsFrom:aFolderPath relPath:relPath
| dir a elements attchPath fileName aStream |

dir:= FileDirectory on: (aFolderPath , relPath).
elements :=dir entries.
elements do:[:entry|
	(entry isDirectory) 
	ifTrue:[
		(relPath='') 
			ifTrue:[	self importAllPartialsFrom:aFolderPath relPath:(entry name)]
			ifFalse:[	self importAllPartialsFrom:aFolderPath relPath:(relPath , FileDirectory pathNameDelimiter asString, entry name)]
	]
	ifFalse:[
		(relPath='') 
			ifFalse:[attchPath:=(relPath , FileDirectory pathNameDelimiter asString, entry name)]
			ifTrue:[attchPath:=( entry name)].
		
		attchPath:= attchPath copyReplaceAll: '\' with: '/'.
		fileName:= entry name copyFrom:1 to:((entry name indexOf:$.) - 1). 
		aStream := StandardFileStream readOnlyFileNamed: entry fullName.	
		self partials at: fileName put: (aStream contents ) 

	]
]! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/12/2012 11:23'!
initialize 
super initialize.
stack:= OrderedCollection new.
parser:=MustacheParser new.
self cache ifNil:[self cache: Dictionary new].
(self cache size > Mustache cacheSize) ifTrue:[
	self cache keys do:[:aKey|
		self cache removeKey: aKey.
		(self cache size < ((Mustache cacheSize / 2 ))) ifTrue:[ ^self].
		]
	]


! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/21/2012 03:07'!
lookup:name stack:aStack 
"looks up the value of the given 'name' in the given context 'stack'"

^self lookup:name stack:aStack defaultValue:nil! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 20:16'!
lookup:name stack:aStack defaultValue:defaultValue
"looks up the value of the given 'name' in the given context 'stack'"
|names lastIndex target value context i j localStack|

(name = '.') ifTrue:[	^ aStack last	].
names:= name subStrings:'.'.
lastIndex:= names size.
target:= names at:lastIndex.

i:=aStack size.
localStack:=aStack copy.

i to:1 by: -1 do:[:pos|
	context := aStack at: pos.
	j:=1.
	[(j < lastIndex) and:[context notNil]] whileTrue:[
		context:=context at: (names at:j).
		j:= j + 1.
		localStack add: context.	
	].

	
	context ifNotNil:[
		((context isKindOf: JsonObject) and:[ context includesKey: target]) ifTrue:[
			value:= context at:target.
			"(value isKindOf: BlockClosure) ifTrue:[value:= value]."
			(value isKindOf: BlockClosure) ifTrue:[value:= value valueWithEnoughArguments: (Array with: localStack last)].
			value ifNil:[^defaultValue].
			^value.
		]
	]
].
(value isKindOf: BlockClosure) ifTrue:[value:= value valueWithEnoughArguments: (Array with: localStack last)].
value ifNil:[^defaultValue].
^value.! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 5/23/2012 19:44'!
parser
	^ parser! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 5/23/2012 19:44'!
parser: anObject
	parser := anObject! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 8/29/2012 00:04'!
partials
^partials ifNil:[partials:=Dictionary new].
	! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 5/19/2012 02:14'!
partials: anObject
	partials := anObject! !

!Mustache methodsFor: 'private' stamp: 'JesusMari 9/23/2012 16:42'!
rcompile:aTemplate options:options

| body context compiledBlock my aTempl i| 

i:=1.

"Replace all the $' occurrences by $'''"
aTempl:=WriteStream on:''.
aTemplate do:[:aChar|
	(aChar = $') ifTrue:[	aTempl nextPut:$';nextPut:$']
				ifFalse:[aTempl nextPut:aChar]
	] .

body:= parser parse: (aTempl contents ) options: options.
my:=Mustache new.
my stack:self stack.
my partials:self partials.

[
	compiledBlock:= (Compiler evaluate:body contents for: my logged:false ).
	compiledBlock ifNil:[self error:'Compilation Error']
]on:Error
do:[:err|
	Transcript show: (err description);
		show: (aTemplate truncateTo: 80);
		show:body contents].
	
^ compiledBlock ! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/21/2012 01:01'!
render: aTemplate view:aView 
"High-level function that renders the given 'template' using the given 'view' and 'partials'. If you need to use any of the template options (see #compile method, you must compile in a separate step, and then call that compiled block) "
| cm |

cm:= self compile:aTemplate.
cm outerContext receiver stack:self stack.
cm outerContext receiver partials:self partials.
^cm valueWithEnoughArguments: (Array with:aView with:partials) contents! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 16:38'!
render: aTemplate view:aView partials:partialsTemp
"High-level function that renders the given 'template' using the given 'view' and 'partials'. If you need to use any of the template options (see #compile method, you must compile in a separate step, and then call that compiled block) "
| cm |
self partials:partialsTemp.
cm:= self compile:aTemplate.
cm outerContext receiver stack:self stack.
cm outerContext receiver partials:self partials.
^cm valueWithEnoughArguments: (Array with:aView with:partials) contents! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/21/2012 02:59'!
renderSection:name view: aStack callback: callback
^ self renderSection:name view: aStack callback: callback inverted:false.
! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 17:12'!
renderSection:name view: aStack callback: callback inverted:inverted

| buffer value scopeRender |

buffer:= ReadWriteStream on:''.
value:= self lookup: name stack: aStack.
inverted 
ifTrue: [
	"From the spec: inverted sections may render text once based on the inverse value of the key. That is, they will be rendered if the key doesn't exist, is false, or is an empty list"
	value ifNil:[buffer nextPutAll: (callback value )	].
	((value isKindOf:Boolean) and:[value not]) ifTrue:[buffer nextPutAll: (callback value )	].		
	((value isKindOf:Array) and:[value isEmpty]) ifTrue:[buffer nextPutAll: (callback value )	].	
	]
ifFalse:[
	(value isKindOf:Array)
	ifTrue:[
		value do:[:val|
			stack add:val.
			buffer nextPutAll: (callback value).
			stack remove:val.
			]
		]
	ifFalse:[
		(value isKindOf:JsonObject)
		ifTrue:[
			stack add:value.
			buffer nextPutAll: (callback value).
			stack remove:value.
			]
		ifFalse:[
			(value isKindOf:BlockClosure)
			ifTrue:[
				
				"scopeRender:=[	:template |
						|scope|
						scope:=stack last.
						 self render:template view:scope partials:nil]."
				
				buffer nextPutAll: (value value: (callback value )).
				]
			ifFalse:[
				(value notNil and:[value]) ifTrue: [buffer nextPutAll:(callback value)].
				]
			]
		
		]
	].
^buffer contents! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:40'!
stack
	^ stack! !

!Mustache methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:40'!
stack: anObject
	stack := anObject! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/19/2012 02:34'!
tags
	parser tags! !

!Mustache methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/19/2012 02:35'!
tags: twoTags
	parser tags:twoTags! !

Object subclass: #MustacheParser
	instanceVariableNames: 'name version tags view partials'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Core'!

!MustacheParser methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/22/2012 17:00'!
debug: aMessage template: aTemplate line: lineNumber file: fileName
|horror|
horror:= 
	aMessage,' in ', 
	(aTemplate copyFrom:1 to: lineNumber),
	'(^v^)' , 
	(aTemplate copyFrom:lineNumber to:aTemplate size),
	String crlf ,
	'Char:', lineNumber asString, 
	String crlf. 
Transcript show: horror.
^horror! !

!MustacheParser methodsFor: 'as yet unclassified' stamp: 'JesusMari 7/12/2012 11:07'!
initialize 
super initialize.
name:='mustache'.
version:= '0.5.0-dev'.
tags:= Array with:'{{' with:'}}'.

! !

!MustacheParser methodsFor: 'as yet unclassified' stamp: 'JesusMari 5/23/2012 19:38'!
messageSelectorAndArgumentNames
| stack |
[:aView :aPartials|
		|buffer line|
	 	buffer:= ReadWriteStream on:''.
	 	line:=1.
	 	buffer nextPutAll:'*'.
.

line:=1.
		buffer nextPutAll: (self escapeHTML:(self lookup:'nombre' stack:stack defaultValue: (String new))).
buffer nextPutAll:'*'
.

line:=1.
		buffer nextPutAll: (self escapeHTML:(self lookup:'profesion' stack:stack defaultValue: (String new))).
buffer nextPutAll:'
*'
.

line:=1.
		buffer nextPutAll: (self escapeHTML:(self lookup:'empresa' stack:stack defaultValue: (String new))).
buffer nextPutAll:'
*'
.

line:=1.
		buffer nextPutAll: (self lookup:'empresa' stack:stack defaultValue: (String new)).
	buffer nextPutAll:'
'
.

line:=1.
		[ |nameexperiencia callbackexperiencia|
		nameexperiencia:='experiencia'.
		callbackexperiencia:=[ 
			|bufferexperiencia|
			bufferexperiencia:=ReadWriteStream on:''.
			bufferexperiencia nextPutAll:'--'
.

line:=1.
		bufferexperiencia nextPutAll: (self escapeHTML:(self lookup:'profesion' stack:stack defaultValue: (String new))).
bufferexperiencia nextPutAll:'
'
.
bufferexperiencia contents].

	buffer nextPutAll: (self renderSection:nameexperiencia view:stack callback:callbackexperiencia).
			buffer contents.
			] value.
	buffer nextPutAll:'
'
.

line:=1.
		[ |nametasas callbacktasas|
		nametasas:='tasas'.
		callbacktasas:=[ 
			|buffertasas|
			buffertasas:=ReadWriteStream on:''.
			buffertasas nextPutAll:''.

line:=1.
		buffertasas nextPutAll: (self escapeHTML:(self lookup:'paga' stack:stack defaultValue: (String new))).
buffertasas nextPutAll:' por '
.

line:=1.
		buffertasas nextPutAll: (self escapeHTML:(self lookup:'profesion' stack:stack defaultValue: (String new))).
buffertasas nextPutAll:'
'
.
buffertasas contents].

	buffer nextPutAll: (self renderSection:nametasas view:stack callback:callbacktasas).
			buffer contents.
			] value.
	buffer nextPutAll:''.
	buffer contents].! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:42'!
name
	^ name! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:41'!
name: anObject
	name := anObject! !

!MustacheParser methodsFor: 'parser' stamp: 'JesusMari 5/19/2012 00:21'!
parse: aTemplate 
"Parses the given 'template' and returns the source of a function that, with the proper arguments, will render the template. Recognized options include the following:
- file The name of the file the template comes from (displayed in error message)
- tags An Array of open and close tags the template uses. Defaults to the value of Mustache tags instance variable.
- debug Set 'true' to log the body of the generated function to the console.
- space Set 'true' to preserve whitespaces from lines that otherwise contain only a {{tag}}. Default to 'false' "

self parse: aTemplate options:(JsonObject new)! !

!MustacheParser methodsFor: 'parser' stamp: 'JesusMari 9/23/2012 17:06'!
parse: aTemplate options:aJsonObjOptions
"Parses the given 'template' and returns the source of a function that, with the proper arguments, will render the template. Recognized options include the following:
- file The name of the file the template comes from (displayed in error message)
- tags An Array of open and close tags the template uses. Defaults to the value of Mustache tags instance variable.
- debug Set 'true' to log the body of the generated function to the console.
- space Set 'true' to preserve whitespaces from lines that otherwise contain only a {{tag}}. Default to 'false' "

|myTags code openTag closeTag spaces hasTag nonSpace streapSpace sectionStack updateLine nextOpenTag nextCloseTag setTags includePartial openSection line  openInvertedSection closeSection sendPlain sendEscaped c callback i end sourceCode lastI |

myTags:=aJsonObjOptions at:'tags' ifAbsent:[self tags].
openTag:=myTags at:1.
closeTag:=myTags at:2.
code:= ReadWriteStream on:''.
sectionStack:=Stack new.
code  
		nextPutAll: 	'[:aView :aPartials|
		|buffer line|
	 	buffer:= ReadWriteStream on:',$' asString,$' asString,'.
	 	line:=0.
	 	buffer nextPutAll:';nextPut:$'.
	
spaces:=Stack new.   "Indices of whitespace in code on the current line"
hasTag:= false.      "Is there a {{tag}} on the current line"	
nonSpace:= false.      "Is there a non-space char on the current line"

streapSpace:=[
	(hasTag and:[nonSpace not and:[(aJsonObjOptions at:'space' ifAbsent:[false]) not]])	
	ifTrue:[
		"???? TODO"
		]
	].

setTags:=[:source :bool :aName|
	|section|
	myTags:= source trimSpaces subStrings: (Character space asString).
	nextOpenTag:= myTags at:1.
	nextCloseTag:=myTags at:2.		
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code nextPutAll: '.
		buffer',section ,' nextPutAll:';nextPut:$'.
	 ].

includePartial:=[:source :bool :aName|
	|section|
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code nextPutAll: '.';crlf;
		nextPutAll: updateLine;
		nextPutAll:'[|partial|
			partial:= partials at:';
		nextPut: $';
		nextPutAll: source trimSpaces;
		nextPut: $';
		nextPutAll:' ifAbsent:[nil].
		partial ifNotNil:[ buffer', section  ,' nextPutAll: (self render:partial view: (stack last) partials:partials)]] value.';crlf;
		nextPutAll:'buffer', section  ,' nextPutAll:';nextPut:$'.
	].

openSection:=[:source :inverted |
	|aName|
	aName:= source trimSpaces.
	(aName = '') ifTrue: [self debug:'Section name may not be empty' template:aTemplate line:line file:(aJsonObjOptions at:'file')].
	
	sectionStack push: (JsonObject fromAssociations: {'name'-> aName. 'inverted'->inverted}).
	code  nextPutAll: '.';crlf;
		nextPutAll:  updateLine;
		nextPutAll: '
		[ |name',aName ,' callback',aName ,'|
		name',aName ,':=';
		nextPut: $';
		nextPutAll: aName; 
		nextPut: $';
		nextPut: $.;
		nextPutAll:'
		callback',aName ,':=[ 
			|buffer',aName ,'|
			buffer',aName ,':=ReadWriteStream on:';nextPut: $';nextPut: $';
			nextPutAll:'.
			buffer',aName ,' nextPutAll:';nextPut:$'.
].

openInvertedSection:= 	[:source|
	openSection value:source value:true.		
	] .

closeSection:=[:source |
	|aName section openName|
	aName:= source trimSpaces.
	openName:=nil.
	(sectionStack size > 0) 
	ifTrue:[
		openName:=sectionStack pop. 
	].

	(openName name isNil or:[(aName = openName name) not]) 
	ifTrue: [
		self error: (self debug:'Section name may not be empty' template:aTemplate line:line file:(aJsonObjOptions at:'file'))
		].
	section:=openName.
	code  nextPutAll: '.';crlf
		;nextPutAll:'buffer',aName ,' contents].';crlf.

	(section at:'inverted' ifAbsent:[false]) 
	ifTrue:[
		code crlf;nextPutAll:'	buffer nextPutAll: (self renderSection:name',aName ,' view:stack callback:callback',aName ,' inverted:true).
			buffer contents.
		] value.'.
		]
	ifFalse:[
		code crlf;nextPutAll:'	buffer nextPutAll: (self renderSection:name',aName ,' view:stack callback:callback',aName ,').
			buffer contents.
			] value.'.
		].
	code crlf;
	nextPutAll:'	buffer nextPutAll:';nextPut:$'.

].

sendPlain:=[:source :bool :aName|
	|section|
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code  nextPutAll: '.';crlf;
		nextPutAll:  updateLine;
		nextPutAll: '
		buffer',section ,' nextPutAll: (self lookup:';
		nextPut:$';
		nextPutAll: source trimSpaces ;
		nextPut:$';
		nextPutAll:' stack:stack defaultValue: (String new)).';
		crlf;
		nextPutAll:'	buffer',section ,' nextPutAll:';nextPut:$'.
	].

sendEscaped:=[:source :bool  :aName|
	|section|
	section:= aName ifNil:['']
					  ifNotNil:[aName name].
	code  nextPutAll: '.';crlf;
		nextPutAll: updateLine;
		nextPutAll: '
		buffer',section ,' nextPutAll: (self escapeHTML:(self lookup:';
		nextPut:$';
		nextPutAll: source trimSpaces ;
		nextPut:$';
		nextPutAll:' stack:stack defaultValue: (String new))).';
		crlf;
		nextPutAll:'buffer',section ,' nextPutAll:';nextPut:$'.
	].
line:=1. i:=1. lastI:=1.
i:=aTemplate findString: openTag startingAt: i.

((i - lastI)>0) ifTrue:  [
		|pos|
		pos:= (i=1) ifTrue:[1] ifFalse:[i-1].
		code nextPutAll:( aTemplate copyFrom:lastI to:(pos)).
		code nextPut:$';nextPut:$.;crlf.
	] ifFalse:[code nextPut:$';crlf].

[i >0] whileTrue:[
	c:= aTemplate at:(i + (openTag size)) .
	line:=i.
	updateLine:=  '
	line:=' , line asString, '.'.
	nextOpenTag:=openTag.
	nextCloseTag:=closeTag.
	hasTag:=true.
	i:= (i + (openTag size)).
	nonSpace:=true.
	callback:=sendEscaped.
	(c=$!!) ifTrue:[
		i:=i+1.
		callback:=nil.
		].
	(c=$=) ifTrue:[
		i:=i+1.
		closeTag:= '=' , closeTag.
		callback:=setTags.
		].
	(c=$>) ifTrue:[
		i:=i+1.
		callback:=includePartial
		].
	(c=$#) ifTrue:[
		closeTag:= closeTag.
		"needs to skip one crlf"
		i:=i+1.
		callback:=openSection
		].
	(c=$^) ifTrue:[
		i:=i+1.
		callback:=openInvertedSection
		].
	(c=$/) ifTrue:[
		closeTag:= closeTag.
			"needs to skip one crlf"
		i:=i+1.
		callback:=closeSection
		].
	(c=${) ifTrue:[
		i:=i+1.
		closeTag:='}' , closeTag.
		callback:=sendPlain.
		].
	(c=$&) ifTrue:[
		i:=i+1.
		nonSpace:=true.
		callback:=sendPlain.
		].

	end:=(aTemplate findString: closeTag startingAt:i).
	(end = 0) ifTrue: 
		[self error: (self debug:('Tag ', openTag, ' was not closed properly') template:aTemplate line:line file:(aJsonObjOptions at:'file'))].

	sourceCode:= aTemplate copyFrom:i to: (end - 1).
	callback 
	ifNotNil:
		[callback valueWithEnoughArguments: (Array with:sourceCode with:false with: (
			sectionStack isEmpty ifTrue:[nil]
								  ifFalse:[sectionStack top]))]
	ifNil:
		[code nextPutAll: 'buffer nextPutAll:';nextPut:$'.].
	lastI:= (end + closeTag size).
	openTag:=nextOpenTag.
	closeTag:=nextCloseTag.
	i:=aTemplate findString: openTag startingAt:lastI.
	
	((i - lastI)>=0) ifTrue:  [
			|pos|
			pos:= (i=1) ifTrue:[1] ifFalse:[i-1].
			lastI:=self skipOneCrlfOn:aTemplate at:lastI command:c.
			code nextPutAll:( aTemplate copyFrom:lastI to:pos).
			code nextPut:$';crlf.
		].
	].
	
	(sectionStack size=0) ifFalse: [self error: (self debug:('Section ', ((sectionStack pop) at:'name'), ' was not closed properly') template:aTemplate line:line file:(aJsonObjOptions at:'file'))].
	lastI:=self skipOneCrlfOn:aTemplate at:lastI command:c.
	code nextPutAll:( aTemplate copyFrom:lastI to:(aTemplate size)).
	code nextPut:$';
		nextPutAll: '.
	buffer contents].'.
^code.	! !

!MustacheParser methodsFor: 'parser' stamp: 'JesusMari 6/18/2012 13:30'!
skipOneCrlfOn:aTemplate at:lastI command:aChar
"skips one CRLF to avoid multiple line break after clossing a section"
(aTemplate size > lastI) ifTrue:[

	(((aTemplate at: lastI )= Character cr ) and: [(aChar=$# or:[aChar=$^]) or:[aChar=$/]])
	 ifTrue:[
		|i|
		i:= lastI+1.
		((aTemplate at:i) = Character lf) ifTrue: [i:= i+1].
		^i.
		]
	].
^lastI

! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:41'!
tags
	^ tags! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:42'!
tags: anArrayOfTwoDelimiters
	tags := anArrayOfTwoDelimiters! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:41'!
version
	^ version! !

!MustacheParser methodsFor: 'accessing' stamp: 'JesusMari 5/18/2012 12:41'!
version: anObject
	version := anObject! !

Object subclass: #MustacheTestRunner
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mustache-Test'!

!MustacheTestRunner class methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 17:34'!
testCompileFile:aFileName
| compiler aStream a tmp b c d |


aStream := StandardFileStream readOnlyFileNamed: aFileName .
a:=JsonObject new.
b:=JsonObject new.
c:=JsonObject new.
d:=JsonObject new.
a name:'Jesus Mar'.
d name:' alias "Jon".'.
a person:d.
a profession:'shift leader'.
a salary:2500.
a wrapped: [:v| |retorno calc|
		retorno:='salary 13% of: ', v asString.
		calc := (v - (v * 13 / 100)) asFloat .
		retorno := retorno , calc asString, ' Euros'.
		] .
a inCa:true.
a company:'<b>Tirme</b>'.
b job:'Electrician'.
c job:'Singer'.
a experience: (Array with:b with:c).
a repo: Array new.
a funcion:[ 1*2*3*4 *100].

compiler:=Mustache new.
compiler importAllPartialsFrom: 'D:\smalltalk\SCouchViewServer\parts\'.
tmp:= compiler render: (aStream contents) view: a. 
Transcript show: tmp.
aStream close! !

!MustacheTestRunner class methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/23/2012 20:47'!
testCompileTemplate:aTemplate
"run in workspace:   MustacheTestRunner testCompileTemplate: MustacheTestX"
| aStream a tmp b c d |
a:=JsonObject new.
b:=JsonObject new.
c:=JsonObject new.
d:=JsonObject new.
a name:'Jesus Mar'.
d name:' alias "Jon".'.
d funcion:[:ds|ds name].
a person:d.
a profession:'shift leader'.
a salary:2500.
a wrapped: [[:v| |retorno calc|
		retorno:='salary 13% of: ', v asString.
		calc := (v - (v * 13 / 100)) asFloat .
		retorno := retorno , calc asString, ' Euros'.
		]].
a inCa:true.
a company:'<b>Tirme</b>'.
b job:'Electrician'.
c job:'Singer'.
a experience: (Array with:b with:c).
a repo: Array new.
a funcion:[ :stash| (stash salary * 0.9) asString , ' Euros' ].
tmp:= Mustache render: aTemplate view:a.
Transcript show: tmp.


! !

!MustacheTestRunner methodsFor: 'as yet unclassified' stamp: 'JesusMari 9/22/2012 17:26'!
seeClassSide! !
